subroutine setup_rates(MAXLEV,n,weight,energy,ups,aij,ne,t,a,b)
use precision
implicit none
integer :: i,j,n,MAXLEV
real(long),parameter :: hck=1.438835d0   ! the ratio of the planck constant to the boltzmann constant
                                         ! the speed of light appears as we use energies in cm^-1 hck=hc/k
real(long) :: weight(MAXLEV),energy(MAXLEV),ups(MAXLEV,MAXLEV),aij(MAXLEV,MAXLEV),ne,t
real(long) :: a(MAXLEV,MAXLEV),b(MAXLEV)
real(long) :: hckt,cij,cji,tnefac
tnefac=8.631D-6*ne/sqrt(t)  ! This is a common factor in all the rates
a=0.d0
b=0.d0
hckt=hck/t
do i = 1, n-1
  do j = i+1,n
! cij is the upward rate, cji the downward.    
    cji=tnefac/weight(j)*ups(j,i)         ! The downward rate is simply proportional to ups
    cij=cji*weight(j)/weight(i)*exp(-hckt*(energy(j)-energy(i)))  ! This factor is simply the ratio of the populations in TE
! Each rate appears twice, once on the diagonal and once off
! aij only contribute to the downward rates.  In the full case
! with an incoming radiation field there would also be contributions to the
! upward rates.    
    a(i,j)=a(i,j)-cji-aij(j,i)    
    a(j,i)=a(j,i)-cij
    a(i,i)=a(i,i)+cij
    a(j,j)=a(j,j)+cji+aij(j,i)
  enddo
enddo
! The last equation is special and gives the total number density is fixed.
do j=1,n
  a(n,j)=1.d0
enddo
! We normalize to 1 since we are only interested in line ratios.
! Normally the abundance would appear here.
b(n)=1.d0
return
end
  
