subroutine calc_inv(a,ap,n,cmax,indx,iswitch)
! iswitch = 0 for lured/reslv iswitch = 1 for ludcmp/lubksb
  use precision
  implicit none
  integer :: i,j,k,n,indx(n),iswitch
  real(long) :: a(n,n),ap(n,n),cmax,c,d
  real(long),allocatable,dimension(:,:)  :: ainv
  allocate(ainv(n,n))
  ainv=0.d0
! We could put the iswitch inside the loop but this is more efficient
! only one test instead of n  
  if(iswitch.eq.0) then
    call ludcmp(a,n,n,indx,d)
    do i=1,n
      ainv(i,i)=1.d0
! ainv is initially the ith unit vector.  In fortran the first index changes
! fastest so this call gives the vector a(1:n,i) to reslv/lubksb     
      call lubksb(a,n,n,indx,ainv(1,i))
    enddo
  else
    call lured(a,n,n)
    do i=1,n
      ainv(i,i)=1.d0
      call reslv(a,ainv(1,i),n,n)
    enddo
  endif
  cmax=0.d0
  do i = 1, n
    do j= 1,n
      c=0.d0
      do k=1,n
        c=c+ap(k,i)*ainv(j,k)
      enddo
! look for the largest error. Since c=1.0 for i=j we subtract this off
      if(i.eq.j) then
        cmax=max(cmax,abs(c-1.d0))
      else
        cmax=max(cmax,abs(c))
      endif
    enddo
  enddo
  deallocate(ainv)
  return
end
